/*
 * Copyright 2011 Steven Gribble
 *
 *  This file is part of the UW CSE 333 course project sequence
 *  (333proj).
 *
 *  333proj is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  333proj is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <assert.h>

#include "CUnit/Basic.h"
#include "doctable.h"

extern void MISAddPoints(int points);

void DTTestSimple(void) {
  DocTable t1;
  char *f1 = "foo/bar/baz.txt", *f2 = "bar/baz.txt", *fres;
  uint64_t d1, d2, dres;

  t1 = AllocateDocTable();
  CU_ASSERT_PTR_NOT_NULL_FATAL(t1);
  CU_ASSERT_EQUAL_FATAL(DTNumDocsInDocTable(t1), 0);
  MISAddPoints(5);

  d1 = DTRegisterDocumentName(t1, f1);
  CU_ASSERT_NOT_EQUAL_FATAL(d1, 0);
  CU_ASSERT_EQUAL_FATAL(DTNumDocsInDocTable(t1), 1);
  d2 = DTRegisterDocumentName(t1, f2);
  CU_ASSERT_NOT_EQUAL_FATAL(d2, 0);
  CU_ASSERT_EQUAL_FATAL(DTNumDocsInDocTable(t1), 2);
  MISAddPoints(5);

  dres = DTRegisterDocumentName(t1, f2);
  CU_ASSERT_EQUAL_FATAL(dres, d2);
  dres = DTRegisterDocumentName(t1, f1);
  CU_ASSERT_EQUAL_FATAL(dres, d1);
  MISAddPoints(5);

  dres = DTLookupDocumentName(t1, f1);
  CU_ASSERT_EQUAL_FATAL(dres, d1);
  dres = DTLookupDocumentName(t1, "nonexistent/file");
  CU_ASSERT_EQUAL_FATAL(dres, 0);
  fres = DTLookupDocID(t1, d1);
  CU_ASSERT_EQUAL_FATAL(strcmp(fres, f1), 0);
  fres = DTLookupDocID(t1, (uint64_t) 0xDEADBEEF);
  CU_ASSERT_EQUAL_FATAL(fres, NULL);
  MISAddPoints(5);

  FreeDocTable(t1);
  MISAddPoints(10);
}
