/*
 * Copyright 2011 Steven Gribble
 *
 *  This file is part of the UW CSE 333 course project sequence
 *  (333proj).
 *
 *  333proj is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  333proj is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <assert.h>

#include "CUnit/Basic.h"
#include "filecrawler.h"
#include "doctable.h"
#include "memindex.h"

extern void MISAddPoints(int points);

void FCTestSimple(void) {
  int res;
  DocTable dt;
  MemIndex idx;

  res = CrawlFileTree("./test_tree/bash-4.2/support", &dt, &idx);
  CU_ASSERT_EQUAL_FATAL(res, 1);
  MISAddPoints(10);
  FreeDocTable(dt);
  FreeMemIndex(idx);
  MISAddPoints(10);

  res = CrawlFileTree("./nonexistent/", &dt, &idx);
  CU_ASSERT_EQUAL_FATAL(res, 0);
  MISAddPoints(10);
  res = CrawlFileTree("./test_suite.c", &dt, &idx);
  CU_ASSERT_EQUAL_FATAL(res, 0);
  MISAddPoints(10);
}
